package test;

import java.io.Reader;
import java.util.ArrayList;
import java.util.List;

import org.yaml.snakeyaml.LoaderOptions;
import org.yaml.snakeyaml.Yaml;

public class BigDocParser {
    private Yaml parser;

    public BigDocParser(LoaderOptions options) {
        parser = new Yaml(options);
    }

    public Object parse(Reader yamlDoc) {
        return parser.load(yamlDoc);
    }

    public List<Object> parseAll(Reader yamlDoc) {
        Iterable<Object> result = parser.loadAll(yamlDoc);
        List<Object> documents = new ArrayList<>();
        for (Object document : result) {
            documents.add(document);
        }
        return documents;
    }
}
