package test;

import java.io.File;
import java.io.FileReader;
import java.util.List;

import org.junit.jupiter.api.Test;
import org.yaml.snakeyaml.LoaderOptions;

import static org.junit.jupiter.api.Assertions.assertNotNull;

public class BigDocParserTests {
    @Test
    public void load_withCustomLimit_works() throws Exception {
        LoaderOptions options = new LoaderOptions();
        options.setAllowDuplicateKeys(false);
        options.setCodePointLimit(5*1024*1024);

        BigDocParser parser = new BigDocParser(options);

        File yamlFile = new File("src/test/resources/big-model.yaml").getAbsoluteFile();
        try (FileReader reader = new FileReader(yamlFile)) {
            Object result = parser.parse(reader);
            assertNotNull(result, "Parsing large doc with load() should return object");
        }
    }

    @Test
    public void loadAll_withCustomLimit_works() throws Exception {
        LoaderOptions options = new LoaderOptions();
        options.setAllowDuplicateKeys(false);
        options.setCodePointLimit(5*1024*1024);

        BigDocParser parser = new BigDocParser(options);

        File yamlFile = new File("src/test/resources/big-model.yaml").getAbsoluteFile();
        try (FileReader reader = new FileReader(yamlFile)) {
            List<Object> result = parser.parseAll(reader);
            assertNotNull(result, "Parsing large doc with loadAll() should return list object");
        }
    }
}
